<!doctype html>
<html>

<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

	<title>Pseudocode</title>

	<link rel="icon" type="image/png" href="images/org_symbol.png" />
	<link rel="stylesheet" href="css/reset.css">
	<link rel="stylesheet" href="css/reveal.css">

	<link rel="stylesheet" href="css/theme/black.css" id="theme">

	<!-- Theme used for syntax highlighting of code -->
	<link rel="stylesheet" href="lib/css/monokai.css">

	<style>
		section{ data-background-image:"images/org_symbol.png"; data-background-size:"8%"; data-background-position:"top 5% left 1%"; }
	</style>

	<!-- Printing and PDF exports -->
	<script>
		var link = document.createElement('link');
		link.rel = 'stylesheet';
		link.type = 'text/css';
		link.href = window.location.search.match(/print-pdf/gi) ? 'css/print/pdf.css' : 'css/print/paper.css';
		document.getElementsByTagName('head')[0].appendChild(link);
	</script>
</head>

<body>
	<div style="background:green; left:0; right:0; position:absolute; height:30px;">
		<div style="text-align: center;">(U)Unclassified</div>
	</div>
	<div class="reveal">
		<div class="slides">
			<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
				<section>
					<h1>Pseudocode</h1>
				</section>
				<section >
					<h2>Course Summary</h2>
					<ul>
						<li><em>Basics of Binary</em></li>
						<li>What is Pseudocode?</li>
						<li>Parts of a Flowchart</li>
						<li>Structured Code</li>
					</ul>
				</section>
				<section>
                        <h2>Objectives</h2>
                        <a href="../objectives.html" target="_blank">Pseudocode Objectives</a>
				</section>
			</section>
			<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
				<section>
					<h2>Binary</h2>
					<h3>The number system computers run on</h3>
				</section>
				<section>
					<h2>There are 10 types of people in this world.</h2>
					<img src="../assets/binarypeople.jpg" alt="binarypeople">
					<p>By the end of this section, you'll understand this joke</p>
				</section>
				<section>
					<img src="../assets/binaryswitches.png" alt="binaryswitches">
					<ul>
						<li>In the binary number system, there are only two digits, 0 and 1.</li>
						<li>Using the picture above, we can physically represent binary with on and off switches.</li>
					</ul>
				</section>
				<section>
					<img src='../assets/powers_of_2.png' alt="powers of 2" width="750">
					<ul>
						<li>Each digit in a binary number, if there is a 1, indicates a power of 2</li>
					</ul>
				</section>
				<section>
					<h2>Example #1</h2>
					<img src='../assets/binary_example_1.png' alt="binary example 1" width="750">
				</section>
				<section>
					<h2>Example #2 </h2>
					<img src='../assets/binary_example_2.png' alt="binary example 2" width="750">
				</section>
				<section>
					<h2>Example #3 </h2>
					<img src='../assets/binary_example_3.png' alt="binary example 3" width="750">
				</section>
				<section>
					<h2>Binary, Decimal, and Hexadecimal</h2>
					<img src="../assets/decimal_binary_hex.gif" alt="Conversion between bases" eight="500">
				</section>
				<section>
					<img src="../assets/base_compare.png" alt="Comparing the different bases" width="500">
				</section>
				<section>
					<h2>Why are Christmas and Halloween the same for a programmer?</h2>
				</section>
				<section>
					<h2>Computers use <b style="color: #1976">base 2</b></h2>
					<h3>i.e. multiples of 2</h3>
					<h3>e.g. base <b style="color: #1976">8</b>, base <b style="color: #1976">16</b></h3>
					<h3>Are very helpful!</h3>
				</section>
				<section>
					<h2>Dec 25</h2>
					<h2>=</h2>
					<h2>Oct 31</h2>
				</section>
				<section>
					<h2>Ascii to Binary</h2>
					<h2>...</h2>
					<h3>Letters are more than just counting in binary</h3>
				</section>
				<section>
					<h2>But not by much</h2>
					<img height="400" src="../assets/USASCII_code_chart.png" alt="Basis for ASCII chart"><br />
					<a style="font-size: 80%"" href=" https://en.wikipedia.org/wiki/ASCII">Reference here</a>
				</section>
				<section>
					<img src="../assets/ASCII-Table-wide.png" alt="Modern ASCII table">
					<a style="font-size: 80%"" href="https://upload.wikimedia.org/wikipedia/commons/1/1b/ASCII-Table-wide.svg">Reference here</a>
				</section>
				<section>
					<h2>Operations</h2>
					<ul>
						<li>There are two different types of operations you can perform on numbers:
							<ul>
								<li>Logical</li>
								<li>Relational</li>
							</ul>
						</li>
					</ul>
				</section>
				<section>
					<h2>Logical Operations</h2>
					<table>
						<tr>
							<td><img src="../assets/and_truth_table.png" alt="AND Truth Table" width="400"></td>
							<td><img src="../assets/or_truth_table.png" alt="OR Truth Table" width="400"></td>
							<td><img src="../assets/xor_truth_table.png" alt="XOR Truth Table" width="400"></td>
						</tr>
					</table>
				</section>
				<section>
					<img src='../assets/binary_and_operations.png' alt="Binary AND Example" width="750">
				</section>
				<section>
					<img src='../assets/binary_or_operations.png' alt="Binary OR Example" width="750">
				</section>
				<section>
					<img src='../assets/binary_xor_operations.png' alt="Binary XOR Example" width="750">
				</section>
				<section>
					<h2>Binary Lab #1</h2> 
					<ul>
						<li>Generate two random numbers through Google's random number generator</li>
						<li>Compute the binary representation of those numbers</li>
						<li>Compute the AND, OR, XOR results of the two numbers</li>
					</ul>
				</section>
				<section>
					<h2>Relational Operators</h2>
					<ul>
						<li>==, EQUAL: test to see if two items are the same</li>
						<li>!=, NOT EQUAL: test to see if two items are not the same</li>
						<li>&gt;, GREATER THAN: test to see if the first item is greater than the second item</li>
						<li>&lt;, LESS THAN: test to see if the first item is less than the second item</li>
						<li>&gt;=, GREATER THAN OR EQUAL</li>
						<li>&lt;=, LESS THAN OR EQUAL</li>
					</ul>
				</section>
			</section>
			<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
				<section>
					<h2>What is Pseudocode?</h2>
					<ul>
						<li>The process of describing a program with plain human language</li>
						<li>While pseudocode uses conventions of a programming language, it is intended for human reading</li>
						<li>Pseudocode typically does not have strict syntax rules</li>
						<li>Can also use flowcharts to present the program</li>
					</ul>
				</section>
				<section>
					<h2>Why pseudocode?</h2>
					<ul>
						<li>Weeks of programming save hours of planning</li>
						<li>The absence of a plan is a plan to fail</li>
						<li>If you don't know where you're going how will you get there?</li>
					</ul>
				</section>
				<section>
					<h2>Why pseudocode?</h2>
					<ul>
						<li><b>Planning - </b></li>
						<li>Improves program efficiency</li>
						<li>Improves program design</li>
						<li>Can fix problems before they arise</li>
						<li>Helps you from getting lost in the weeds</li>
					</ul>
				</section>
				<section>
					<h3>Pseudocode text</h3>
					<table style='font-size:80%'>
						<tr>
							<td>Type</td>
							<td>Example</td>
						</tr>
						<tr>
							<td>Start/stop</td>
							<td>Programs begin with start, end with stop<br>start and stop are aligned </td>
						</tr>
						<tr>
							<td>Statements - basic commands </td>
							<td>
								<ul>
									<li>Initialize variable</li>
									<li>Increment value</li>
									<li>Print value</li>
								</ul>
							</td>
						</tr>
						<tr>
							<td>Mathematical operations</td>
							<td>Addition, subtraction, comparison, variable assignment</td>
						</tr>
						<tr>
							<td>Keywords</td>
							<td>Written in all caps - reserved by language. E.g. GET, SET, PRINT, RETURN </td>
						</tr>
					</table>
				</section>
				<section>
					<table style='font-size:80%'>
						<tr>
							<td>Type</td>
							<td>Example</td>
						</tr>
						<tr>
							<td>Conditionals and<br>Loops </td>
							<td>
								<ul>
									<li>IF ELSE</li>
									<li>CASE* </li>
									<li>WHILE </li>
									<li>FOR / FOR EACH</li>
								</ul>
							</td>
						</tr>
						<tr>
							<td>Functions </td>
							<td>Little 'sub' programs / methods </td>
						</tr>
						<tr>
							<td>Exception handling </td>
							<td>What happens when something is wrong / breaks / is not planned for </td>
						</tr>
					</table>
				</section>
			</section>
			<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
				<section>
					<h3>Parts of a flowchart:</h3>
					<table>
						<tr>
							<td>Purpose</td>
							<td>Symbol</td>
						</tr>
						<tr>
							<td>Start/stop (terminator) </td>
							<td>Oval</td>
						</tr>
						<tr>
							<td>Input/output</td>
							<td>Parallelogram</td>
						</tr>
						<tr>
							<td>Decisions (or tests)</td>
							<td>Diamond</td>
						</tr>
						<tr>
							<td>Processing/actions</td>
							<td>Rectangle</td>
						</tr>
					</table>
				</section>
				<section>
					<h2>Parts of a flowchart</h2>
					<p style='font-size:30%'>Image from <a href="https://xkcd.com/518/">xkcd</a></p>
					<img height=500; src="../assets/xkcd_flow_charts.png">
				</section>
				<section>
					<h3>Flowchart actions</h3>
					<img height=500 src="../assets/flowchart_actions.png">
				</section>
				<section>
					<h3>Flowchart decisions</h3>
					<img src="../assets/flowchart_decisions.png">
				</section>
				<section>
					<h3>Parts of a flowchart:</h3>
					<ul>
						<li>start/stop</li>
						<li>decisions</li>
						<li>input/output</li>
						<li>actions</li>
					</ul>
				</section>
			</section>
			<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
				<section>
					<h2>Two Truths and a Lie</h2>
					<h3>The Disadvantages of Unstructured Spaghetti Code</h3>
					<ul>
						<li>Spaghetti code is the descriptive name for logically snarled programs.</li>
						<li>Programs written using spaghetti code cannot produce correct results.</li>
						<li>Programs written using spaghetti code are more difficult to maintain than other programs.</li>
					</ul>
				</section>
				<section>
					<h2>Structure</h2>
					<ul>					
					<li>Basic unit of programming logic </li>
					<li>Each structure is one of the following:
						<ul>
						<li>Sequence structure</li>
						<li>Selection structure (decision structure)</li>
						<li>Loop structure</li>
						</ul>
					</li>
					<li>Any program can be constructed using any combination of these three structures</li>
					</ul>
				</section>
				<section>
					<h2>Sequence Structure</h2>
					<img src="../assets/sequence.png">
				</section>
				<section>
					<h2>Selection Structure</h2>
					<img src="../assets/selection.png">
				</section>
				<section>
					<h2>Loop Structure</h2>
					<img src="../assets/looping_structure.png">
				</section>
				<section>
					<h2>Loop structure</h2>
					<ul>
						<li>Loop body - Repeats a set of actions while a condition remains true</li>
						<li>Also called repetition or iteration</li>
						<li>Condition is tested first in the most common form of loop</li>
						<li>The do while or while loop</li>
					</ul>
				</section>
				<section>
					<h2>Combining Structures</h2>
					<ul>
						<li>All logic problems can be solved using only sequence, selection, and loop</li>
						<li>Structures can be combined in an infinite number of ways</li>
						<li>Stacking structures
							<ul>
								<li>Attaching structures end-to-end</li>
							</ul>
						</li>
					</ul>
				</section>
				<section>
					<h2>Combining Structures</h2>
					<img src="../assets/stacking.png">
				</section>
				<section>
					<h2>Nesting Structures</h2>
					<ul>
						<li>Any individual task or step in a structure can be replaced by a structure</li>
						<li>This can cause one structure to be placed within another</li>
						<li>The nested structure will have indented statements</li>
					</ul>
					<h2>Block</h2>
					<p>A group of statements that execute as a single unit</p>
				</section>
				<section>
					<img src="../assets/combiningStructure.png">
				</section>
				<section>
					<img src="../assets/combiningstructure1.png">
				</section>
				<section>
					<img src="../assets/combiningstr2.png">
				</section>
				<section>
					<img src="../assets/combiningstr3.png">
				</section>
				<section>
					<h2>Structured programs have the following characteristics:</h2>
					<ul>
						<li>Include combinations of the three basic structures</li>
						<li>Each structure has a single entry point and a single exit point</li>
						<li>Structures can be stacked or connected to one another only at their entry or exit points</li>
						<li>Any structure can be nested within another structure</li>
					</ul>
				</section>
				<section>
					<h2>Understanding The Reasons for Structure</h2>
					<ul>
						<li>Use structured programming for:
						<ul>
							<li>Clarity—unstructured programs are confusing</li>
							<li>Professionalism—other programmers expect it</li>
							<li>Efficiency—most languages support it</li>
							<li>Maintenance —other programmers find it easier to read</li>
							<li>Modularity —easily broken down into modules</li>
						</ul></li>
						<li>Structured programming is sometimes called goto-less programming</li>
					</ul>
				</section>
				<section>
					<img src="../assets/Dogwashing2.png" height="650">
				</section>
				<section>
					<img src="../assets/dogwashing3.png" height="650">
				</section>
			</section>
			<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
				<section>
					<h2>Questions?</h2>
				</section>
				<section >
					<h2>Course Summary</h2>
					<ul>
						<li><em>Basics of Binary</em></li>
						<li>What is Pseudocode?</li>
						<li>Parts of a Flowchart</li>
						<li>Structured Code</li>
					</ul>
				</section>
			</section>
		</div>
	</div>
	<script src="js/reveal.js"></script>

	<script>
		Reveal.initialize({
			slideNumber: true,
			hash: true,
			menu: {
				side: 'left',
				width: 'normal',
				numbers: true,
				titleSelector: 'h1, h2, h3, h4, h5, h6',
				useTextContentForMissingTitles: false,
				hideMissingTitles: false,
				markers: true,
				custom: false,
				themes: true,
				themesPath: 'css/theme/',
				transitions: true,
				openButton: true,
				openSlideNumber: true,
				keyboard: true,
				sticky: true,
				autoOpen: true,
				delayInit: false,
				openOnInit: false,
				loadIcons: true
			},
			dependencies: [
				{ src: 'plugin/markdown/marked.js' },
				{ src: 'plugin/markdown/markdown.js' },
				{ src: 'plugin/highlight/highlight.js' },
				{ src: 'plugin/notes/notes.js', async: true },
				{ src: 'plugin/reveal.js-menu/menu.js' }
			]
		});
		Reveal.configure({ slideNumber: true })
	</script>
</body>

</html>
